//Jury-rigged script that downloads a file from a given url. Unzips as a zip file if argument 2 == 1.
//I pretty much copied this from the download plugins script.
//Argument 0: Filename to use.
//Argument 1: URL.
//Argument 2: Zip file?
    var tempfile, tempdir, url, handle, lastContact, zip;
	zip = argument2;
	failed = false;
	lastContact = 0;
    if zip {
		tempfile = temp_directory + "\" + argument0 + ".zip.tmp";
		tempdir = temp_directory + "\" + argument0 + ".tmp";
	} else {
		tempfile = temp_directory + "\" + argument0 + ".tmp";
	}
        url = argument1;
        handle = http_new_get(url);
        while (!http_step(handle)) {
            io_handle();            
            if (!global.isHost) {
                if (current_time-lastContact > 20000) {
                    write_byte(global.serverSocket, PING);
                    socket_send(global.serverSocket);
                    lastContact = current_time;
                }
            }
        }
		
        if (http_status_code(handle) != 200)
        {
            show_error('Error downloading file. Please send the contents of this message to geofferymartin@gmail.com. #DEBUG: ' + string(http_status_code(handle)) + ' ' + http_reason_phrase(handle),1);
            failed = true;
            break;
        }
        else
        {
            write_buffer_to_file(http_response_body(handle), tempfile);
            if (!file_exists(tempfile))
            {
                show_error('Error downloading file. Please send the contents of this message to geofferymartin@gmail.com. #DEBUG: No such file?',1);
                failed = true;
                break;
            }
        }

        http_destroy(handle);
		
    if zip {
	    extractzip(tempfile, tempdir);
		if (!directory_exists(tempdir))
		{
			show_error('Error downloading file. Please send the contents of this message to geofferymartin@gmail.com. #DEBUG: extracting zip failed',1);
			failed = true;
			break;
		}
	}
	
    if failed exit;
	else return tempfile;